天天看点

Codeforces 710E Generate a String【dp】好题!

E. Generate a String time limit per test 2 seconds memory limit per test 512 megabytes input standard input output standard output

zscoder wants to generate an input file for some programming competition problem.

His input is a string consisting of n letters 'a'. He is too lazy to write a generator so he will manually generate the input in a text editor.

Initially, the text editor is empty. It takes him x seconds to insert or delete a letter 'a' from the text file and y seconds to copy the contents of the entire text file, and duplicate it.

zscoder wants to find the minimum amount of time needed for him to create the input file of exactly n letters 'a'. Help him to determine the amount of time needed to generate the input.

Input

The only line contains three integers n, x and y (1 ≤ n ≤ 107, 1 ≤ x, y ≤ 109) — the number of letters 'a' in the input file and the parameters from the problem statement.

Output

Print the only integer t — the minimum amount of time needed to generate the input file.

Examples Input

8 1 1
      

Output

4
      

Input

8 1 10
      

Output

8      

题目大意:

初始值为0,目标值为N,+1或者-1的操作对应花费为x,*2的操作对应花费为y、问最小花费。

思路:

1、考虑dp,设定dp【i】表示目标值为i的时候的最小花费。

那么直接写出其状态转移方程:

dp【i】=min(dp【i+1】,dp【i-1】)+x;

dp【i】=min(dp【i】,dp【i/2】)+y;

2、那么我们发现,其中因为+1,-1的操作会使得dp过程中会存在环,而我们此时只进行了一次状态转移,那么显然有情况会达不到最优、

接下来思路来自大牛:http://www.cnblogs.com/from00/p/5799795.html

①这个数如果是从i-1过来的,那么一定有:dp【i】=min(dp【i-1】+y,dp【i】);

②这个数如果是偶数,那么一定有:dp【i】=min(dp【i/2】+y,dp【i】);

③这个数如果是奇数,那么一定有:dp【i】=min(dp【i/2+1】+y+x,dp【i】);表示从(i/2+1)*2-1操作转移过来。

Ac代码:

#include<stdio.h>
#include<iostream>
#include<string.h>
using namespace std;
#define ll __int64
ll dp[20000006];
int main()
{
    int n;
    ll x,y;
    while(~scanf("%d%I64d%I64d",&n,&x,&y))
    {
        for(int i=1;i<=2*n;i++)dp[i]=2000000000000000000;
        dp[1]=x;
        for(int i=2;i<=2*n;i++)
        {
            dp[i]=min(dp[i],dp[i-1]+x);
            if(i%2==0)
            {
                dp[i]=min(dp[i],dp[i/2]+y);
            }
            else dp[i]=min(dp[i],dp[i/2+1]+y+x);
        }
        printf("%I64d\n",dp[n]);
    }
}